//-----------------------------------------------------------------------------
// config.m
//
// handles functions of the config panel 
//
// by iPlayTheSpoons
//
//-----------------------------------------------------------------------------

#include "../../../lib/std.mi"

Function ShadowOpacity(Int Var);
Function TickerSet(String Var);
Function TickerColor(String red, String green, String blue);
Function TimeColor(String red, String green, String blue);
Function LoadPreset();

Global Container MainContainer;
Global Layout NormalLayout, ShadeLayout, StickLayout;
Global Layer Shadow1, Shadow2, Shadow3, Shadow4, Shadow5, Shadow6, Shadow7;
Global Text MainTick, ShadeTick, StickTick, ThingerTick, MainTime, ShadeTime, StickTime;
Global Slider GlassSlider, ShadowSlider, RedSlider,GreenSlider,BlueSlider;
Global String RedT, GreenT, BlueT;
Global Button TickerCheckBox, ResetColor, ColorText, ColorTime, ChooseColor;

System.onScriptLoaded() { 

	MainContainer = getContainer("main");
	NormalLayout = MainContainer.getLayout("normal");
	ShadeLayout = MainContainer.getLayout("shade");
	StickLayout = MainContainer.getLayout("stick");
	Layout ThingerLayout = getContainer("thinger").getLayout("normal");
	Group MainLCD = NormalLayout.getObject("lcd");
	Group ThingLCD = NormalLayout.getObject("thinger");
	Group ShadeLCD = ShadeLayout.getObject("shade.lcd");
	Group StickLCD = StickLayout.getObject("stick.lcd");
	Group Thingerstuff = ThingerLayout.getObject("thinger.junk");
	Group ConfigStuff = getscriptgroup();
	Group RightCont = NormalLayout.getObject("right.speaker");
	Group LeftCont = NormalLayout.getObject("left.speaker");
	
	Shadow1 = NormalLayout.getObject("main.shadow");
	Shadow2 = LeftCont.getObject("speaker.left.shadow");
	Shadow3 = RightCont.getObject("speaker.right.shadow");
	Shadow4 = ShadeLayout.findObject("shade.shadow");
	Shadow5 = ShadeLayout.findObject("shade.drawer.bottom.shadow");
	Shadow6 = StickLayout.findObject("stick.shadow");
	Shadow7 = StickLayout.findObject("slider.shadow");
	
	MainTick = MainLCD.getObject("SongTicker");
	ShadeTick = ShadeLCD.getObject("SongTicker");
	StickTick = StickLCD.getObject("SongTicker");
	ThingerTick = Thingerstuff.getObject("cbtext");
	MainTime = MainLCD.getObject("time");
	ShadeTime = ShadeLCD.getObject("time");
	StickTime = StickLCD.getObject("time");
	
	ShadowSlider = ConfigStuff.getObject("shadow.slider");
	RedSlider = ConfigStuff.getObject("red.slider");
	GreenSlider = ConfigStuff.getObject("green.slider");
	BlueSlider = ConfigStuff.getObject("blue.slider");
	ResetColor = ConfigStuff.getObject("reset.color");
	TickerCheckBox = ConfigStuff.getObject("ticker.checkbox");
	ColorText = ConfigStuff.getObject("colortext.checkbox");
	ColorTime = ConfigStuff.getObject("colortime.checkbox");
	ChooseColor = ConfigStuff.getObject("choose.color");

	
	ShadowSlider.setPosition(getPrivateInt("PAD","ShadowOpacity",255));
	RedSlider.setPosition(getPrivateInt("PAD","Red",81));
	GreenSlider.setPosition(getPrivateInt("PAD","Green",81));
	BlueSlider.setPosition(getPrivateInt("PAD","Blue",81));
	TickerCheckBox.setActivated(system.getPrivateInt("PAD","TickerSetting",1));
	ColorText.setActivated(system.getPrivateInt("PAD","ColorTextSetting",1));
	ColorTime.setActivated(system.getPrivateInt("PAD","ColorTimeSetting",1));
	TickerSet(integertoString(system.getPrivateInt("PAD","TickerSetting",1)));
		
}


ShadowSlider.onSetPosition(int x) {
	ShadowOpacity(x);
}

ChooseColor.onLeftClick() {
	LoadPreset();
}

ResetColor.onLeftClick() {
	RedSlider.setPosition(81);
	GreenSlider.setPosition(81);
	BlueSlider.setPosition(81);
}

RedSlider.onSetPosition(int x) {
	system.setPrivateInt("PAD","Red",x);
	RedT = integerToString(getPrivateInt("PAD","Red",81));
	GreenT = integerToString(getPrivateInt("PAD","Green",81));
	BlueT = integerToString(getPrivateInt("PAD","Blue",81));
	if(system.getPrivateInt("PAD","ColorTextSetting",1) == 1){
	TickerColor(RedT, GreenT, BlueT);}
	if(system.getPrivateInt("PAD","ColorTimeSetting",1) == 1){
	TimeColor(RedT, GreenT, BlueT);}
}

GreenSlider.onSetPosition(int x) {
	system.setPrivateInt("PAD","Green",x);
	RedT = integerToString(getPrivateInt("PAD","Red",81));
	GreenT = integerToString(getPrivateInt("PAD","Green",81));
	BlueT = integerToString(getPrivateInt("PAD","Blue",81));
	if(system.getPrivateInt("PAD","ColorTextSetting",1) == 1){
	TickerColor(RedT, GreenT, BlueT);}
	if(system.getPrivateInt("PAD","ColorTimeSetting",1) == 1){
	TimeColor(RedT, GreenT, BlueT);}
}

BlueSlider.onSetPosition(int x) {
	system.setPrivateInt("PAD","Blue",x);
	RedT = integerToString(getPrivateInt("PAD","Red",81));
	GreenT = integerToString(getPrivateInt("PAD","Green",81));
	BlueT = integerToString(getPrivateInt("PAD","Blue",81));
	if(system.getPrivateInt("PAD","ColorTextSetting",1) == 1){
	TickerColor(RedT, GreenT, BlueT);}
	if(system.getPrivateInt("PAD","ColorTimeSetting",1) == 1){
	TimeColor(RedT, GreenT, BlueT);}
}


TickerCheckBox.onActivate(Int x) {
	system.setPrivateInt("PAD","TickerSetting",x);
	TickerSet(integerToString(x));
}

ColorText.onActivate(Int x) {
	system.setPrivateInt("PAD","ColorTextSetting",x);
	If (x == 0){
	TickerColor("81", "81", "81");}
	If (x == 1){
	RedT = integerToString(getPrivateInt("PAD","Red",81));
	GreenT = integerToString(getPrivateInt("PAD","Green",81));
	BlueT = integerToString(getPrivateInt("PAD","Blue",81));
	TickerColor(RedT, GreenT, BlueT);}
}

ColorTime.onActivate(Int x) {
	system.setPrivateInt("PAD","ColorTimeSetting",x);
	If (x == 0){
	TimeColor("81", "81", "81");}
	If (x == 1){
	RedT = integerToString(getPrivateInt("PAD","Red",81));
	GreenT = integerToString(getPrivateInt("PAD","Green",81));
	BlueT = integerToString(getPrivateInt("PAD","Blue",81));
	TimeColor(RedT, GreenT, BlueT);}
}

ShadowOpacity(Int Var) {
	system.setPrivateInt("PAD","ShadowOpacity",Var);
	Shadow1.setAlpha(Var);
	Shadow2.setAlpha(Var);
	Shadow3.setAlpha(Var);
	Shadow4.setAlpha(Var);
	Shadow5.setAlpha(Var);
	Shadow6.setAlpha(Var);
	Shadow7.setAlpha(Var);
}

TickerSet(String Var) {
	MainTick.setXMLParam("ticker",Var);
	ShadeTick.setXMLParam("ticker",Var);
	StickTick.setXMLParam("ticker",Var);
	ThingerTick.setXMLParam("ticker",Var);
}

TickerColor(String red, String green, String blue) {
	MainTick.setXMLParam("color", red+", "+green+", "+blue);
	ShadeTick.setXMLParam("color", red+", "+green+", "+blue);
	StickTick.setXMLParam("color", red+", "+green+", "+blue);
	ThingerTick.setXMLParam("color", red+", "+green+", "+blue);
}

TimeColor(String red, String green, String blue) {
	MainTime.setXMLParam("color", red+", "+green+", "+blue);
	ShadeTime.setXMLParam("color", red+", "+green+", "+blue);
	StickTime.setXMLParam("color", red+", "+green+", "+blue);
}

LoadPreset() {
	String Preset = getPrivateString("Pad","Preset","No Preset");
	if (Preset == "No Preset") {
		RedSlider.setPosition(81);
		GreenSlider.setPosition(81);
		BlueSlider.setPosition(81);
	}
	if (Preset == "Track Red") {
		RedSlider.setPosition(200);
		GreenSlider.setPosition(81);
		BlueSlider.setPosition(81);
	}
	if (Preset == "Track Blue") {
		RedSlider.setPosition(100);
		GreenSlider.setPosition(115);
		BlueSlider.setPosition(200);
	}
	if (Preset == "Track Green") {
		RedSlider.setPosition(95);
		GreenSlider.setPosition(203);
		BlueSlider.setPosition(146);
	}
	if (Preset == "Track Purple") {
		RedSlider.setPosition(97);
		GreenSlider.setPosition(58);
		BlueSlider.setPosition(135);
	}
	if (Preset == "Deviant Art") {
		RedSlider.setPosition(78);
		GreenSlider.setPosition(140);
		BlueSlider.setPosition(97);
	}
	if (Preset == "Copper") {
		RedSlider.setPosition(169);
		GreenSlider.setPosition(165);
		BlueSlider.setPosition(122);
	}
	if (Preset == "Aqua") {
		RedSlider.setPosition(100);
		GreenSlider.setPosition(80);
		BlueSlider.setPosition(241);
	}
	if (Preset == "Track Orange") {
		RedSlider.setPosition(210);
		GreenSlider.setPosition(103);
		BlueSlider.setPosition(51);
	}
	if (Preset == "Track Yellow") {
		RedSlider.setPosition(199);
		GreenSlider.setPosition(210);
		BlueSlider.setPosition(51);
	}
	if (Preset == "Default Blue") {
		RedSlider.setPosition(146);
		GreenSlider.setPosition(165);
		BlueSlider.setPosition(169);
	}
}