//-----------------------------------------------------------------------------
// main.m
//
// handles the speakers (duhhh)
//
// by iPlayTheSpoons
//
//-----------------------------------------------------------------------------

#include "../../../lib/std.mi"

Function UpdateRight(Int Var);
Function UpdateLeft(Int Var);

Global Container MainContainer;
Global Layout NormalLayout;
Global Group RightCont, LeftCont, SystemGroup;
Global AnimatedLayer RightVis, LeftVis;
Global Button Toggle;
Global Timer VisTimer;
Global Double Level, OneFrame;
Global Int LastFrame1, LastFrame2, SpeakerPos;

System.onScriptLoaded() { 

	MainContainer = getContainer("main");
	NormalLayout = MainContainer.getLayout("normal"); 
	
	RightCont = NormalLayout.getObject("right.speaker");
	LeftCont = NormalLayout.getObject("left.speaker");
	RightVis = RightCont.getObject("MainVis");
	LeftVis = LeftCont.getObject("MainVis");
	SystemGroup = NormalLayout.getObject("system");
	Toggle = SystemGroup.getObject("toggle");
	
	VisTimer = new Timer;
	VisTimer.setDelay(50);
	VisTimer.start();
	LeftVis.setSpeed(50);
	RightVis.setSpeed(50);
	OneFrame = 255/5;
	
	If (System.getPrivateInt("PAD", "Speakers_Position", 0) == 1) {
		Toggle.leftClick();
	}
}

System.onScriptUnloading() {
  VisTimer.stop();
  delete VisTimer;
}

Toggle.onLeftClick(){
	if(SpeakerPos == 0){
		SpeakerPos = 1;
		System.setPrivateInt("PAD", "Speakers_Position", 1);
		RightCont.setTargetX(163);
		RightCont.setTargetSpeed(0.5);
		LeftCont.setTargetX(124);
		LeftCont.setTargetSpeed(0.5);
		RightCont.gotoTarget();
		LeftCont.gotoTarget();
	}
	else if(SpeakerPos == 1){
		SpeakerPos = 0;
		VisTimer.start();
		LeftCont.show();
		RightCont.show();
		System.setPrivateInt("PAD", "Speakers_Position", 0);
		RightCont.setTargetX(255);
		RightCont.setTargetSpeed(0.5);
		LeftCont.setTargetX(29);
		LeftCont.setTargetSpeed(0.5);
		RightCont.gotoTarget();
		LeftCont.gotoTarget();
	}
}

LeftCont.onTargetReached() {
	if(SpeakerPos == 1){
	VisTimer.stop();
	LeftCont.hide();
	RightCont.hide();
	}
}

VisTimer.onTimer() {
	Level = (System.getLeftVuMeter());
		UpdateLeft(Level/OneFrame);
    Level = (System.getRightVuMeter());
		UpdateRight(Level/OneFrame);
}		

UpdateLeft(Int Var){
	{
		LeftVis.setStartFrame(LastFrame1);
     	LeftVis.setEndFrame(Var);
     	LeftVis.play();
     	LastFrame1 = Var;
	}
}

UpdateRight(Int Var){
	{
		RightVis.setStartFrame(LastFrame2);
     	RightVis.setEndFrame(Var);
     	RightVis.play();
     	LastFrame2 = Var;
	}
}